Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 327)
+++ lemon/lgf_reader.h	(revision 220)
@@ -19,5 +19,5 @@
 ///\ingroup lemon_io
 ///\file
-///\brief \ref lgf-format "LEMON Graph Format" reader.
+///\brief \ref lgf-format "Lemon Graph Format" reader.
 
 
@@ -32,4 +32,5 @@
 #include <map>
 
+#include <lemon/assert.h>
 #include <lemon/core.h>
 
@@ -48,11 +49,9 @@
         std::istringstream is(str);
         Value value;
-        if (!(is >> value)) {
-          throw FormatError("Cannot read token");
-        }
+        is >> value;
 
         char c;
         if (is >> std::ws >> c) {
-          throw FormatError("Remaining characters in token");
+          throw DataFormatError("Remaining characters in token");
         }
         return value;
@@ -168,5 +167,5 @@
           std::ostringstream msg;
           msg << "Item not found: " << str;
-          throw FormatError(msg.str());
+          throw DataFormatError(msg.str().c_str());
         }
         return it->second;
@@ -186,10 +185,10 @@
       typename Graph::Arc operator()(const std::string& str) {
         if (str.empty() || (str[0] != '+' && str[0] != '-')) {
-          throw FormatError("Item must start with '+' or '-'");
+          throw DataFormatError("Item must start with '+' or '-'");
         }
         typename std::map<std::string, typename Graph::Edge>
           ::const_iterator it = _map.find(str.substr(1));
         if (it == _map.end()) {
-          throw FormatError("Item not found");
+          throw DataFormatError("Item not found");
         }
         return _graph.direct(it->second, str[0] == '+');
@@ -237,5 +236,5 @@
       char c;
       if (!is.get(c))
-        throw FormatError("Escape format error");
+        throw DataFormatError("Escape format error");
 
       switch (c) {
@@ -266,5 +265,5 @@
           int code;
           if (!is.get(c) || !isHex(c))
-            throw FormatError("Escape format error");
+            throw DataFormatError("Escape format error");
           else if (code = valueHex(c), !is.get(c) || !isHex(c)) is.putback(c);
           else code = code * 16 + valueHex(c);
@@ -275,5 +274,5 @@
           int code;
           if (!isOct(c))
-            throw FormatError("Escape format error");
+            throw DataFormatError("Escape format error");
           else if (code = valueOct(c), !is.get(c) || !isOct(c))
             is.putback(c);
@@ -302,5 +301,5 @@
         }
         if (!is)
-          throw FormatError("Quoted format error");
+          throw DataFormatError("Quoted format error");
       } else {
         is.putback(c);
@@ -391,35 +390,12 @@
   class DigraphReader;
 
-  /// \brief Return a \ref DigraphReader class
-  ///
-  /// This function just returns a \ref DigraphReader class.
-  /// \relates DigraphReader
   template <typename Digraph>
-  DigraphReader<Digraph> digraphReader(Digraph& digraph,
-                                       std::istream& is = std::cin) {
-    DigraphReader<Digraph> tmp(digraph, is);
-    return tmp;
-  }
-
-  /// \brief Return a \ref DigraphReader class
-  ///
-  /// This function just returns a \ref DigraphReader class.
-  /// \relates DigraphReader
+  DigraphReader<Digraph> digraphReader(std::istream& is, Digraph& digraph);
+
   template <typename Digraph>
-  DigraphReader<Digraph> digraphReader(Digraph& digraph,
-                                       const std::string& fn) {
-    DigraphReader<Digraph> tmp(digraph, fn);
-    return tmp;
-  }
-
-  /// \brief Return a \ref DigraphReader class
-  ///
-  /// This function just returns a \ref DigraphReader class.
-  /// \relates DigraphReader
+  DigraphReader<Digraph> digraphReader(const std::string& fn, Digraph& digraph);
+
   template <typename Digraph>
-  DigraphReader<Digraph> digraphReader(Digraph& digraph, const char* fn) {
-    DigraphReader<Digraph> tmp(digraph, fn);
-    return tmp;
-  }
+  DigraphReader<Digraph> digraphReader(const char *fn, Digraph& digraph);
 
   /// \ingroup lemon_io
@@ -444,5 +420,5 @@
   ///
   ///\code
-  /// DigraphReader<Digraph>(digraph, std::cin).
+  /// DigraphReader<Digraph>(std::cin, digraph).
   ///   nodeMap("coordinates", coord_map).
   ///   arcMap("capacity", cap_map).
@@ -485,5 +461,4 @@
     std::istream* _is;
     bool local_is;
-    std::string _filename;
 
     Digraph& _digraph;
@@ -525,5 +500,5 @@
     /// Construct a directed graph reader, which reads from the given
     /// input stream.
-    DigraphReader(Digraph& digraph, std::istream& is = std::cin)
+    DigraphReader(std::istream& is, Digraph& digraph)
       : _is(&is), local_is(false), _digraph(digraph),
         _use_nodes(false), _use_arcs(false),
@@ -534,14 +509,8 @@
     /// Construct a directed graph reader, which reads from the given
     /// file.
-    DigraphReader(Digraph& digraph, const std::string& fn)
-      : _is(new std::ifstream(fn.c_str())), local_is(true),
-        _filename(fn), _digraph(digraph),
+    DigraphReader(const std::string& fn, Digraph& digraph)
+      : _is(new std::ifstream(fn.c_str())), local_is(true), _digraph(digraph),
         _use_nodes(false), _use_arcs(false),
-        _skip_nodes(false), _skip_arcs(false) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_arcs(false) {}
 
     /// \brief Constructor
@@ -549,14 +518,8 @@
     /// Construct a directed graph reader, which reads from the given
     /// file.
-    DigraphReader(Digraph& digraph, const char* fn)
-      : _is(new std::ifstream(fn)), local_is(true),
-        _filename(fn), _digraph(digraph),
+    DigraphReader(const char* fn, Digraph& digraph)
+      : _is(new std::ifstream(fn)), local_is(true), _digraph(digraph),
         _use_nodes(false), _use_arcs(false),
-        _skip_nodes(false), _skip_arcs(false) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_arcs(false) {}
 
     /// \brief Destructor
@@ -585,10 +548,10 @@
   private:
 
-    friend DigraphReader<Digraph> digraphReader<>(Digraph& digraph,
-                                                  std::istream& is);
-    friend DigraphReader<Digraph> digraphReader<>(Digraph& digraph,
-                                                  const std::string& fn);
-    friend DigraphReader<Digraph> digraphReader<>(Digraph& digraph,
-                                                  const char *fn);
+    friend DigraphReader<Digraph> digraphReader<>(std::istream& is,
+                                                  Digraph& digraph);
+    friend DigraphReader<Digraph> digraphReader<>(const std::string& fn,
+                                                  Digraph& digraph);
+    friend DigraphReader<Digraph> digraphReader<>(const char *fn,
+                                                  Digraph& digraph);
 
     DigraphReader(DigraphReader& other)
@@ -883,5 +846,5 @@
         if (readSuccess() && line) line.putback(c);
         if (!_node_maps.empty())
-          throw FormatError("Cannot find map names");
+          throw DataFormatError("Cannot find map names");
         return;
       }
@@ -897,5 +860,5 @@
             std::ostringstream msg;
             msg << "Multiple occurence of node map: " << map;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           maps.insert(std::make_pair(map, index));
@@ -908,6 +871,6 @@
           if (jt == maps.end()) {
             std::ostringstream msg;
-            msg << "Map not found: " << _node_maps[i].first;
-            throw FormatError(msg.str());
+            msg << "Map not found in file: " << _node_maps[i].first;
+            throw DataFormatError(msg.str().c_str());
           }
           map_index[i] = jt->second;
@@ -933,9 +896,9 @@
             std::ostringstream msg;
             msg << "Column not found (" << i + 1 << ")";
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
         }
         if (line >> std::ws >> c)
-          throw FormatError("Extra character at the end of line");
+          throw DataFormatError("Extra character on the end of line");
 
         Node n;
@@ -946,5 +909,5 @@
         } else {
           if (label_index == -1)
-            throw FormatError("Label map not found");
+            throw DataFormatError("Label map not found in file");
           typename std::map<std::string, Node>::iterator it =
             _node_index.find(tokens[label_index]);
@@ -952,5 +915,5 @@
             std::ostringstream msg;
             msg << "Node with label not found: " << tokens[label_index];
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           n = it->second;
@@ -976,5 +939,5 @@
         if (readSuccess() && line) line.putback(c);
         if (!_arc_maps.empty())
-          throw FormatError("Cannot find map names");
+          throw DataFormatError("Cannot find map names");
         return;
       }
@@ -990,5 +953,5 @@
             std::ostringstream msg;
             msg << "Multiple occurence of arc map: " << map;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           maps.insert(std::make_pair(map, index));
@@ -1001,6 +964,6 @@
           if (jt == maps.end()) {
             std::ostringstream msg;
-            msg << "Map not found: " << _arc_maps[i].first;
-            throw FormatError(msg.str());
+            msg << "Map not found in file: " << _arc_maps[i].first;
+            throw DataFormatError(msg.str().c_str());
           }
           map_index[i] = jt->second;
@@ -1025,8 +988,8 @@
 
         if (!_reader_bits::readToken(line, source_token))
-          throw FormatError("Source not found");
+          throw DataFormatError("Source not found");
 
         if (!_reader_bits::readToken(line, target_token))
-          throw FormatError("Target not found");
+          throw DataFormatError("Target not found");
 
         std::vector<std::string> tokens(map_num);
@@ -1035,9 +998,9 @@
             std::ostringstream msg;
             msg << "Column not found (" << i + 1 << ")";
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
         }
         if (line >> std::ws >> c)
-          throw FormatError("Extra character at the end of line");
+          throw DataFormatError("Extra character on the end of line");
 
         Arc a;
@@ -1050,5 +1013,5 @@
             std::ostringstream msg;
             msg << "Item not found: " << source_token;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           Node source = it->second;
@@ -1058,5 +1021,5 @@
             std::ostringstream msg;
             msg << "Item not found: " << target_token;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           Node target = it->second;
@@ -1067,5 +1030,5 @@
         } else {
           if (label_index == -1)
-            throw FormatError("Label map not found");
+            throw DataFormatError("Label map not found in file");
           typename std::map<std::string, Arc>::iterator it =
             _arc_index.find(tokens[label_index]);
@@ -1073,5 +1036,5 @@
             std::ostringstream msg;
             msg << "Arc with label not found: " << tokens[label_index];
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           a = it->second;
@@ -1098,9 +1061,9 @@
         std::string attr, token;
         if (!_reader_bits::readToken(line, attr))
-          throw FormatError("Attribute name not found");
+          throw DataFormatError("Attribute name not found");
         if (!_reader_bits::readToken(line, token))
-          throw FormatError("Attribute value not found");
+          throw DataFormatError("Attribute value not found");
         if (line >> c)
-          throw FormatError("Extra character at the end of line");
+          throw DataFormatError("Extra character on the end of line");
 
         {
@@ -1108,6 +1071,6 @@
           if (it != read_attr.end()) {
             std::ostringstream msg;
-            msg << "Multiple occurence of attribute: " << attr;
-            throw FormatError(msg.str());
+            msg << "Multiple occurence of attribute " << attr;
+            throw DataFormatError(msg.str().c_str());
           }
           read_attr.insert(attr);
@@ -1130,6 +1093,6 @@
         if (read_attr.find(it->first) == read_attr.end()) {
           std::ostringstream msg;
-          msg << "Attribute not found: " << it->first;
-          throw FormatError(msg.str());
+          msg << "Attribute not found in file: " << it->first;
+          throw DataFormatError(msg.str().c_str());
         }
       }
@@ -1146,4 +1109,7 @@
     void run() {
       LEMON_ASSERT(_is != 0, "This reader assigned to an other reader");
+      if (!*_is) {
+        throw DataFormatError("Cannot find file");
+      }
 
       bool nodes_done = _skip_nodes;
@@ -1164,5 +1130,5 @@
 
           if (line >> c)
-            throw FormatError("Extra character at the end of line");
+            throw DataFormatError("Extra character on the end of line");
 
           if (section == "nodes" && !nodes_done) {
@@ -1186,7 +1152,6 @@
             skipSection();
           }
-        } catch (FormatError& error) {
+        } catch (DataFormatError& error) {
           error.line(line_num);
-          error.file(_filename);
           throw;
         }
@@ -1194,13 +1159,13 @@
 
       if (!nodes_done) {
-        throw FormatError("Section @nodes not found");
+        throw DataFormatError("Section @nodes not found");
       }
 
       if (!arcs_done) {
-        throw FormatError("Section @arcs not found");
+        throw DataFormatError("Section @arcs not found");
       }
 
       if (!attributes_done && !_attributes.empty()) {
-        throw FormatError("Section @attributes not found");
+        throw DataFormatError("Section @attributes not found");
       }
 
@@ -1210,37 +1175,47 @@
 
   };
+
+  /// \brief Return a \ref DigraphReader class
+  ///
+  /// This function just returns a \ref DigraphReader class.
+  /// \relates DigraphReader
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(std::istream& is, Digraph& digraph) {
+    DigraphReader<Digraph> tmp(is, digraph);
+    return tmp;
+  }
+
+  /// \brief Return a \ref DigraphReader class
+  ///
+  /// This function just returns a \ref DigraphReader class.
+  /// \relates DigraphReader
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(const std::string& fn,
+                                       Digraph& digraph) {
+    DigraphReader<Digraph> tmp(fn, digraph);
+    return tmp;
+  }
+
+  /// \brief Return a \ref DigraphReader class
+  ///
+  /// This function just returns a \ref DigraphReader class.
+  /// \relates DigraphReader
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(const char* fn, Digraph& digraph) {
+    DigraphReader<Digraph> tmp(fn, digraph);
+    return tmp;
+  }
 
   template <typename Graph>
   class GraphReader;
 
-  /// \brief Return a \ref GraphReader class
-  ///
-  /// This function just returns a \ref GraphReader class.
-  /// \relates GraphReader
   template <typename Graph>
-  GraphReader<Graph> graphReader(Graph& graph, std::istream& is = std::cin) {
-    GraphReader<Graph> tmp(graph, is);
-    return tmp;
-  }
-
-  /// \brief Return a \ref GraphReader class
-  ///
-  /// This function just returns a \ref GraphReader class.
-  /// \relates GraphReader
+  GraphReader<Graph> graphReader(std::istream& is, Graph& graph);
+
   template <typename Graph>
-  GraphReader<Graph> graphReader(Graph& graph, const std::string& fn) {
-    GraphReader<Graph> tmp(graph, fn);
-    return tmp;
-  }
-
-  /// \brief Return a \ref GraphReader class
-  ///
-  /// This function just returns a \ref GraphReader class.
-  /// \relates GraphReader
+  GraphReader<Graph> graphReader(const std::string& fn, Graph& graph);
+
   template <typename Graph>
-  GraphReader<Graph> graphReader(Graph& graph, const char* fn) {
-    GraphReader<Graph> tmp(graph, fn);
-    return tmp;
-  }
+  GraphReader<Graph> graphReader(const char *fn, Graph& graph);
 
   /// \ingroup lemon_io
@@ -1270,5 +1245,4 @@
     std::istream* _is;
     bool local_is;
-    std::string _filename;
 
     Graph& _graph;
@@ -1310,5 +1284,5 @@
     /// Construct an undirected graph reader, which reads from the given
     /// input stream.
-    GraphReader(Graph& graph, std::istream& is = std::cin)
+    GraphReader(std::istream& is, Graph& graph)
       : _is(&is), local_is(false), _graph(graph),
         _use_nodes(false), _use_edges(false),
@@ -1319,14 +1293,8 @@
     /// Construct an undirected graph reader, which reads from the given
     /// file.
-    GraphReader(Graph& graph, const std::string& fn)
-      : _is(new std::ifstream(fn.c_str())), local_is(true),
-        _filename(fn), _graph(graph),
+    GraphReader(const std::string& fn, Graph& graph)
+      : _is(new std::ifstream(fn.c_str())), local_is(true), _graph(graph),
         _use_nodes(false), _use_edges(false),
-        _skip_nodes(false), _skip_edges(false) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_edges(false) {}
 
     /// \brief Constructor
@@ -1334,14 +1302,8 @@
     /// Construct an undirected graph reader, which reads from the given
     /// file.
-    GraphReader(Graph& graph, const char* fn)
-      : _is(new std::ifstream(fn)), local_is(true),
-        _filename(fn), _graph(graph),
+    GraphReader(const char* fn, Graph& graph)
+      : _is(new std::ifstream(fn)), local_is(true), _graph(graph),
         _use_nodes(false), _use_edges(false),
-        _skip_nodes(false), _skip_edges(false) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_edges(false) {}
 
     /// \brief Destructor
@@ -1369,8 +1331,8 @@
 
   private:
-    friend GraphReader<Graph> graphReader<>(Graph& graph, std::istream& is);
-    friend GraphReader<Graph> graphReader<>(Graph& graph,
-                                            const std::string& fn);
-    friend GraphReader<Graph> graphReader<>(Graph& graph, const char *fn);
+    friend GraphReader<Graph> graphReader<>(std::istream& is, Graph& graph);
+    friend GraphReader<Graph> graphReader<>(const std::string& fn,
+                                            Graph& graph);
+    friend GraphReader<Graph> graphReader<>(const char *fn, Graph& graph);
 
     GraphReader(GraphReader& other)
@@ -1712,5 +1674,5 @@
         if (readSuccess() && line) line.putback(c);
         if (!_node_maps.empty())
-          throw FormatError("Cannot find map names");
+          throw DataFormatError("Cannot find map names");
         return;
       }
@@ -1726,5 +1688,5 @@
             std::ostringstream msg;
             msg << "Multiple occurence of node map: " << map;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           maps.insert(std::make_pair(map, index));
@@ -1737,6 +1699,6 @@
           if (jt == maps.end()) {
             std::ostringstream msg;
-            msg << "Map not found: " << _node_maps[i].first;
-            throw FormatError(msg.str());
+            msg << "Map not found in file: " << _node_maps[i].first;
+            throw DataFormatError(msg.str().c_str());
           }
           map_index[i] = jt->second;
@@ -1762,9 +1724,9 @@
             std::ostringstream msg;
             msg << "Column not found (" << i + 1 << ")";
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
         }
         if (line >> std::ws >> c)
-          throw FormatError("Extra character at the end of line");
+          throw DataFormatError("Extra character on the end of line");
 
         Node n;
@@ -1775,5 +1737,5 @@
         } else {
           if (label_index == -1)
-            throw FormatError("Label map not found");
+            throw DataFormatError("Label map not found in file");
           typename std::map<std::string, Node>::iterator it =
             _node_index.find(tokens[label_index]);
@@ -1781,5 +1743,5 @@
             std::ostringstream msg;
             msg << "Node with label not found: " << tokens[label_index];
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           n = it->second;
@@ -1805,5 +1767,5 @@
         if (readSuccess() && line) line.putback(c);
         if (!_edge_maps.empty())
-          throw FormatError("Cannot find map names");
+          throw DataFormatError("Cannot find map names");
         return;
       }
@@ -1819,5 +1781,5 @@
             std::ostringstream msg;
             msg << "Multiple occurence of edge map: " << map;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           maps.insert(std::make_pair(map, index));
@@ -1830,6 +1792,6 @@
           if (jt == maps.end()) {
             std::ostringstream msg;
-            msg << "Map not found: " << _edge_maps[i].first;
-            throw FormatError(msg.str());
+            msg << "Map not found in file: " << _edge_maps[i].first;
+            throw DataFormatError(msg.str().c_str());
           }
           map_index[i] = jt->second;
@@ -1854,8 +1816,8 @@
 
         if (!_reader_bits::readToken(line, source_token))
-          throw FormatError("Node u not found");
+          throw DataFormatError("Node u not found");
 
         if (!_reader_bits::readToken(line, target_token))
-          throw FormatError("Node v not found");
+          throw DataFormatError("Node v not found");
 
         std::vector<std::string> tokens(map_num);
@@ -1864,9 +1826,9 @@
             std::ostringstream msg;
             msg << "Column not found (" << i + 1 << ")";
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
         }
         if (line >> std::ws >> c)
-          throw FormatError("Extra character at the end of line");
+          throw DataFormatError("Extra character on the end of line");
 
         Edge e;
@@ -1879,5 +1841,5 @@
             std::ostringstream msg;
             msg << "Item not found: " << source_token;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           Node source = it->second;
@@ -1887,5 +1849,5 @@
             std::ostringstream msg;
             msg << "Item not found: " << target_token;
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           Node target = it->second;
@@ -1896,5 +1858,5 @@
         } else {
           if (label_index == -1)
-            throw FormatError("Label map not found");
+            throw DataFormatError("Label map not found in file");
           typename std::map<std::string, Edge>::iterator it =
             _edge_index.find(tokens[label_index]);
@@ -1902,5 +1864,5 @@
             std::ostringstream msg;
             msg << "Edge with label not found: " << tokens[label_index];
-            throw FormatError(msg.str());
+            throw DataFormatError(msg.str().c_str());
           }
           e = it->second;
@@ -1927,9 +1889,9 @@
         std::string attr, token;
         if (!_reader_bits::readToken(line, attr))
-          throw FormatError("Attribute name not found");
+          throw DataFormatError("Attribute name not found");
         if (!_reader_bits::readToken(line, token))
-          throw FormatError("Attribute value not found");
+          throw DataFormatError("Attribute value not found");
         if (line >> c)
-          throw FormatError("Extra character at the end of line");
+          throw DataFormatError("Extra character on the end of line");
 
         {
@@ -1937,6 +1899,6 @@
           if (it != read_attr.end()) {
             std::ostringstream msg;
-            msg << "Multiple occurence of attribute: " << attr;
-            throw FormatError(msg.str());
+            msg << "Multiple occurence of attribute " << attr;
+            throw DataFormatError(msg.str().c_str());
           }
           read_attr.insert(attr);
@@ -1959,6 +1921,6 @@
         if (read_attr.find(it->first) == read_attr.end()) {
           std::ostringstream msg;
-          msg << "Attribute not found: " << it->first;
-          throw FormatError(msg.str());
+          msg << "Attribute not found in file: " << it->first;
+          throw DataFormatError(msg.str().c_str());
         }
       }
@@ -1994,5 +1956,5 @@
 
           if (line >> c)
-            throw FormatError("Extra character at the end of line");
+            throw DataFormatError("Extra character on the end of line");
 
           if (section == "nodes" && !nodes_done) {
@@ -2016,7 +1978,6 @@
             skipSection();
           }
-        } catch (FormatError& error) {
+        } catch (DataFormatError& error) {
           error.line(line_num);
-          error.file(_filename);
           throw;
         }
@@ -2024,13 +1985,13 @@
 
       if (!nodes_done) {
-        throw FormatError("Section @nodes not found");
+        throw DataFormatError("Section @nodes not found");
       }
 
       if (!edges_done) {
-        throw FormatError("Section @edges not found");
+        throw DataFormatError("Section @edges not found");
       }
 
       if (!attributes_done && !_attributes.empty()) {
-        throw FormatError("Section @attributes not found");
+        throw DataFormatError("Section @attributes not found");
       }
 
@@ -2040,4 +2001,35 @@
 
   };
+
+  /// \brief Return a \ref GraphReader class
+  ///
+  /// This function just returns a \ref GraphReader class.
+  /// \relates GraphReader
+  template <typename Graph>
+  GraphReader<Graph> graphReader(std::istream& is, Graph& graph) {
+    GraphReader<Graph> tmp(is, graph);
+    return tmp;
+  }
+
+  /// \brief Return a \ref GraphReader class
+  ///
+  /// This function just returns a \ref GraphReader class.
+  /// \relates GraphReader
+  template <typename Graph>
+  GraphReader<Graph> graphReader(const std::string& fn,
+                                       Graph& graph) {
+    GraphReader<Graph> tmp(fn, graph);
+    return tmp;
+  }
+
+  /// \brief Return a \ref GraphReader class
+  ///
+  /// This function just returns a \ref GraphReader class.
+  /// \relates GraphReader
+  template <typename Graph>
+  GraphReader<Graph> graphReader(const char* fn, Graph& graph) {
+    GraphReader<Graph> tmp(fn, graph);
+    return tmp;
+  }
 
   class SectionReader;
@@ -2063,5 +2055,4 @@
     std::istream* _is;
     bool local_is;
-    std::string _filename;
 
     typedef std::map<std::string, _reader_bits::Section*> Sections;
@@ -2084,11 +2075,5 @@
     /// Construct a section reader, which reads from the given file.
     SectionReader(const std::string& fn)
-      : _is(new std::ifstream(fn.c_str())), local_is(true),
-        _filename(fn) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+      : _is(new std::ifstream(fn.c_str())), local_is(true) {}
 
     /// \brief Constructor
@@ -2096,11 +2081,5 @@
     /// Construct a section reader, which reads from the given file.
     SectionReader(const char* fn)
-      : _is(new std::ifstream(fn)), local_is(true),
-        _filename(fn) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+      : _is(new std::ifstream(fn)), local_is(true) {}
 
     /// \brief Destructor
@@ -2258,10 +2237,10 @@
 
           if (line >> c)
-            throw FormatError("Extra character at the end of line");
+            throw DataFormatError("Extra character on the end of line");
 
           if (extra_sections.find(section) != extra_sections.end()) {
             std::ostringstream msg;
-            msg << "Multiple occurence of section: " << section;
-            throw FormatError(msg.str());
+            msg << "Multiple occurence of section " << section;
+            throw DataFormatError(msg.str().c_str());
           }
           Sections::iterator it = _sections.find(section);
@@ -2272,7 +2251,6 @@
           readLine();
           skipSection();
-        } catch (FormatError& error) {
+        } catch (DataFormatError& error) {
           error.line(line_num);
-          error.file(_filename);
           throw;
         }
@@ -2283,5 +2261,5 @@
           std::ostringstream os;
           os << "Cannot find section: " << it->first;
-          throw FormatError(os.str());
+          throw DataFormatError(os.str().c_str());
         }
       }
@@ -2324,5 +2302,5 @@
   ///
   /// This class can be used to read the sections, the map names and
-  /// the attributes from a file. Usually, the LEMON programs know
+  /// the attributes from a file. Usually, the Lemon programs know
   /// that, which type of graph, which maps and which attributes
   /// should be read from a file, but in general tools (like glemon)
@@ -2383,10 +2361,5 @@
     /// file.
     LgfContents(const std::string& fn)
-      : _is(new std::ifstream(fn.c_str())), local_is(true) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+      : _is(new std::ifstream(fn.c_str())), local_is(true) {}
 
     /// \brief Constructor
@@ -2395,10 +2368,5 @@
     /// file.
     LgfContents(const char* fn)
-      : _is(new std::ifstream(fn)), local_is(true) {
-      if (!(*_is)) {
-        delete _is;
-        throw IoError("Cannot open file", fn);
-      }
-    }
+      : _is(new std::ifstream(fn)), local_is(true) {}
 
     /// \brief Destructor
